package de.andrena.et2016.check.conventions;

import java.util.Set;

import org.springframework.beans.factory.annotation.AnnotatedBeanDefinition;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.ClassPathScanningCandidateComponentProvider;
import org.springframework.core.type.filter.TypeFilter;

public class ClasspathScanner extends ClassPathScanningCandidateComponentProvider {

	public static ClasspathScanner includingAll() {
		return new ClasspathScanner((metadataReader, metadataReaderFactory) -> true);
	}

	public static ClasspathScanner including(TypeFilter... includeFilters) {
		return new ClasspathScanner(includeFilters);
	}

	private ClasspathScanner(TypeFilter... includeFilters) {
		super(false);
		for (TypeFilter typeFilter : includeFilters) {
			addIncludeFilter(typeFilter);
		}
	}

	public ClasspathScanner exclude(TypeFilter excludeFilter) {
		super.addExcludeFilter(excludeFilter);
		return this;
	}

	public Set<BeanDefinition> scan(String basePackage) {
		return super.findCandidateComponents(basePackage);
	}

	@Override
	protected boolean isCandidateComponent(AnnotatedBeanDefinition beanDefinition) {
		// Don't filter prematurely
		return true;
	}

}
